package com.loganmagnan.lasers.commands;

import com.loganmagnan.lasers.Lasers;
import com.loganmagnan.lasers.runnables.LaserRunnable;
import com.loganmagnan.lasers.utils.ColorUtils;
import com.loganmagnan.lasers.utils.CustomLocation;
import com.loganmagnan.lasers.utils.Utils;
import com.loganmagnan.lasers.utils.command.BaseCommand;
import com.loganmagnan.lasers.utils.command.Command;
import com.loganmagnan.lasers.utils.command.CommandArguments;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;

public class LaserCommand extends BaseCommand {

    private Lasers main = Lasers.getInstance();

    @Command(name = "laser", permission = "laser.admin")
    @Override
    public void executeAs(CommandArguments command) {
        Player player = command.getPlayer();

        String[] args = command.getArgs();

        if (args.length == 0) {
            player.sendMessage(ColorUtils.getMessageType("&cUsage:"));
            player.sendMessage(ColorUtils.getMessageType("  &c/laser start <player> <time> <spawn amount>"));
        } else {
            switch (args[0]) {
                case "start":
                    String name = args[1];

                    if (name == null) {
                        return;
                    }

                    Player target = this.main.getServer().getPlayer(name);

                    if (target == null) {
                        return;
                    }

                    if (!Utils.isNumeric(args[2])) {
                        return;
                    }

                    int time = Integer.parseInt(args[2]);

                    if (!Utils.isNumeric(args[3])) {
                        return;
                    }

                    int spawnAmount = Integer.parseInt(args[3]);

                    Block block = target.getLocation().getBlock();

                    Location location = block.getLocation().clone().add(0, spawnAmount, 0);

                    location.getBlock().setType(Material.REDSTONE_BLOCK);

                    new LaserRunnable(target, location.getBlock()).runTaskTimer(this.main, 0, time);

                    player.sendMessage(ColorUtils.getMessageType("&aYou've started the laser"));

                    break;
            }
        }
    }

    public void saveLocation(Player player, String location) {
        FileConfiguration config = this.main.getMainConfig().getConfig();
        config.set(location, CustomLocation.locationToString(CustomLocation.fromBukkitLocation(player.getLocation())));

        this.main.getMainConfig().save();
    }
}
