package com.loganmagnan.lasers.managers;

import com.loganmagnan.lasers.Lasers;
import lombok.Getter;
import lombok.Setter;
import java.util.*;

@Getter
@Setter
public class CooldownManager {

    private Lasers main = Lasers.getInstance();

    private Set<UUID> cooldown = new HashSet<UUID>();

    private Map<UUID, Integer> cooldownTime = new HashMap<UUID, Integer>();

    private int cooldownCount;

    public int getCooldownTime(UUID player) {
        return this.cooldownTime.get(player);
    }

    public void setCooldown(UUID player, int number) {
        this.cooldown.add(player);
        this.cooldownTime.put(player, number);
    }

    public void setCooldownTime(UUID player, int time) {
        this.cooldownTime.remove(player);
        this.cooldownTime.put(player, time);
    }

    public boolean isOnCooldown(UUID player) {
        return this.cooldown.contains(player);
    }
}
