package com.loganmagnan.lasers.runnables;

import com.loganmagnan.lasers.Lasers;
import com.loganmagnan.lasers.utils.CustomLocation;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import org.bukkit.Color;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Particle;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.util.Vector;

import javax.swing.text.html.parser.Entity;
import java.util.Iterator;
import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

@Getter
@Setter
public class LaserRunnable extends BukkitRunnable {

    private Lasers main = Lasers.getInstance();

    private Player player;

    private Block block;

    private Location location;

    public LaserRunnable(Player player, Block block) {
        this.player = player;
        this.block = block;
        this.location = this.block.getLocation();
    }

    @Override
    public void run() {
        this.moveBlock();
        this.spawnParticle();
    }

//    public Player getPlayer() {
//        Player playerClosest = null;
//
//        double distanceClosest = Double.MAX_VALUE;
//
//        for (Player player : this.main.getServer().getOnlinePlayers()) {
//            double distance = player.getLocation().distanceSquared(this.location);
//
//            if (distance < distanceClosest) {
//                playerClosest = player;
//
//                distanceClosest = distance;
//            }
//        }
//
//        return playerClosest;
//    }

    public Iterable<Vector> getVectorList(Vector startVector, Vector endVector) {
        return () -> new Iterator<Vector>() {
            private Vector currentVector = startVector.clone();
            private Vector direction = endVector.clone().subtract(startVector).normalize();

            private double length = startVector.distance(endVector);
            private double stepSize = 0.10;

            @Override
            public boolean hasNext() {
                return currentVector.distance(endVector) <= length;
            }

            @Override
            public Vector next() {
                Vector vector = currentVector.clone();
                currentVector.add(direction.clone().multiply(stepSize));

                return vector;
            }
        };
    }

    public void spawnParticle() {
        double endX = (Math.random() * 20) - 10;
        double endY = (Math.random() * 20) - 10;
        double endZ = (Math.random() * 20) - 10;

        Location endLocation = this.location.clone().add(endX, endY, endZ);

        Particle.DustOptions dustOptions = new Particle.DustOptions(Color.fromRGB(255, 0, 0), 5);

        for (Vector vectorInList : this.getVectorList(this.location.toVector(), endLocation.toVector())) {
            Location location = vectorInList.toLocation(this.location.getWorld());
            location.getWorld().spawnParticle(Particle.REDSTONE, vectorInList.toLocation(this.location.getWorld()), 1, dustOptions);

            if (this.player.getLocation().distanceSquared(location) < 1) {
                this.player.damage(4);

                if (this.player.getHealth() == 0) {
                    this.cancel();
                    this.location.getBlock().setType(Material.AIR);
                }

                break;
            }
        }
    }

    public void moveBlock() {
        this.location.getBlock().setType(Material.AIR);

        Vector direction = this.player.getLocation().toVector().subtract(this.location.toVector()).normalize();

        Location location = this.location.add(direction.multiply(1.50));
        location.getBlock().setType(Material.REDSTONE_BLOCK);

        this.location = location;

//        if (player == null) {
//            int random = ThreadLocalRandom.current().nextInt(4);
//
//            switch (random) {
//                // North
//                case 0:
//                    this.location = this.location.clone().add(0, 0, -1);
//
//                    break;
//                // East
//                case 1:
//                    this.location = this.location.clone().add(1, 0, 0);
//
//                    break;
//                // South
//                case 2:
//                    this.location = this.location.clone().add(0, 0, 1);
//
//                    break;
//                // West
//                case 3:
//                    this.location = this.location.clone().add(-1, 0, 0);
//
//                    break;
//            }
//
//            this.location.getBlock().setType(Material.REDSTONE_BLOCK);
//        } else {
//            Vector direction = player.getLocation().toVector().subtract(this.location.toVector()).normalize();
//
//            Location location = this.location.add(direction.multiply(1.50));
//            location.getBlock().setType(Material.REDSTONE_BLOCK);
//
//            this.location = location;
//        }
    }
}